"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = exports.Routes = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _react = require("react");
var _reactRouter = require("react-router");
var _classnames = _interopRequireDefault(require("classnames"));
var _lowcodeReactRenderer = _interopRequireDefault(require("@bitwebsvc/lowcode-react-renderer"));
var _mobxReact = require("mobx-react");
var _lowcodeUtils = require("@bitwebsvc/lowcode-utils");
var _lowcodeTypes = require("@bitwebsvc/lowcode-types");
var _host = require("./host");
var _misc = require("./utils/misc");
require("./renderer.less");
var _locale = require("./locale");
var _class, _class2, _class3;
var _excluded = ["_leaf"],
  _excluded2 = ["__id"];
// patch cloneElement avoid lost keyProps
var originCloneElement = window.React.cloneElement;
window.React.cloneElement = function (child, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
    _leaf = _ref._leaf,
    props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  if (child.ref && props.ref) {
    var dRef = props.ref;
    var cRef = child.ref;
    props.ref = function (x) {
      if (cRef) {
        if (typeof cRef === 'function') {
          cRef(x);
        } else {
          try {
            cRef.current = x;
          } catch (e) {
            console.error(e);
          }
        }
      }
      if (dRef) {
        if (typeof dRef === 'function') {
          dRef(x);
        } else {
          try {
            dRef.current = x;
          } catch (e) {
            console.error(e);
          }
        }
      }
    };
  }
  for (var _len = arguments.length, rest = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    rest[_key - 2] = arguments[_key];
  }
  return originCloneElement.apply(void 0, [child, props].concat(rest));
};
var SimulatorRendererView = exports["default"] = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(SimulatorRendererView, _Component);
  function SimulatorRendererView() {
    return _Component.apply(this, arguments) || this;
  }
  var _proto = SimulatorRendererView.prototype;
  _proto.render = function render() {
    var rendererContainer = this.props.rendererContainer;
    return /*#__PURE__*/React.createElement(_reactRouter.Router, {
      history: rendererContainer.history
    }, /*#__PURE__*/React.createElement(Layout, {
      rendererContainer: rendererContainer
    }, /*#__PURE__*/React.createElement(Routes, {
      rendererContainer: rendererContainer
    })));
  };
  return SimulatorRendererView;
}(_react.Component);
var Routes = exports.Routes = (0, _mobxReact.observer)(_class = /*#__PURE__*/function (_Component2) {
  (0, _inheritsLoose2["default"])(Routes, _Component2);
  function Routes() {
    return _Component2.apply(this, arguments) || this;
  }
  var _proto2 = Routes.prototype;
  _proto2.render = function render() {
    var rendererContainer = this.props.rendererContainer;
    return /*#__PURE__*/React.createElement(_reactRouter.Switch, null, rendererContainer.documentInstances.map(function (instance) {
      return /*#__PURE__*/React.createElement(_reactRouter.Route, {
        path: instance.path,
        key: instance.id,
        render: function render(routeProps) {
          return /*#__PURE__*/React.createElement(Renderer, (0, _extends2["default"])({
            documentInstance: instance,
            rendererContainer: rendererContainer
          }, routeProps));
        }
      });
    }));
  };
  return Routes;
}(_react.Component)) || _class;
function ucfirst(s) {
  return s.charAt(0).toUpperCase() + s.substring(1);
}
function getDeviceView(view, device, mode) {
  if (!view || typeof view === 'string') {
    return view;
  }

  // compatible vision Mobile | Preview
  device = ucfirst(device);
  if (device === 'Mobile' && view.hasOwnProperty(device)) {
    view = view[device];
  }
  mode = ucfirst(mode);
  if (mode === 'Preview' && view.hasOwnProperty(mode)) {
    view = view[mode];
  }
  return view;
}
var Layout = (0, _mobxReact.observer)(_class2 = /*#__PURE__*/function (_Component3) {
  (0, _inheritsLoose2["default"])(Layout, _Component3);
  function Layout() {
    return _Component3.apply(this, arguments) || this;
  }
  var _proto3 = Layout.prototype;
  _proto3.render = function render() {
    var _this$props = this.props,
      rendererContainer = _this$props.rendererContainer,
      children = _this$props.children;
    var layout = rendererContainer.layout;
    if (layout) {
      var _Component4 = layout.Component,
        props = layout.props,
        componentName = layout.componentName;
      if (_Component4) {
        return /*#__PURE__*/React.createElement(_Component4, {
          key: "layout",
          props: props
        }, children);
      }
      if (componentName && rendererContainer.getComponent(componentName)) {
        return /*#__PURE__*/(0, _react.createElement)(rendererContainer.getComponent(componentName), (0, _extends2["default"])({}, props, {
          rendererContainer: rendererContainer,
          key: 'layout'
        }), [children]);
      }
    }
    return /*#__PURE__*/React.createElement(_react.Fragment, null, children);
  };
  return Layout;
}(_react.Component)) || _class2;
var Renderer = (0, _mobxReact.observer)(_class3 = /*#__PURE__*/function (_Component5) {
  (0, _inheritsLoose2["default"])(Renderer, _Component5);
  function Renderer() {
    var _this;
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }
    _this = _Component5.call.apply(_Component5, [this].concat(args)) || this;
    _this.startTime = null;
    _this.schemaChangedSymbol = false;
    _this.getSchemaChangedSymbol = function () {
      return _this.schemaChangedSymbol;
    };
    _this.setSchemaChangedSymbol = function (symbol) {
      _this.schemaChangedSymbol = symbol;
    };
    return _this;
  }
  var _proto4 = Renderer.prototype;
  _proto4.componentDidUpdate = function componentDidUpdate() {
    this.recordTime();
  };
  _proto4.recordTime = function recordTime() {
    if (this.startTime) {
      var _host$designer$curren, _host$designer$curren2, _host$designer$editor;
      var time = Date.now() - this.startTime;
      var nodeCount = (_host$designer$curren = _host.host.designer.currentDocument) === null || _host$designer$curren === void 0 ? void 0 : (_host$designer$curren2 = _host$designer$curren.getNodeCount) === null || _host$designer$curren2 === void 0 ? void 0 : _host$designer$curren2.call(_host$designer$curren);
      (_host$designer$editor = _host.host.designer.editor) === null || _host$designer$editor === void 0 ? void 0 : _host$designer$editor.eventBus.emit(_lowcodeTypes.GlobalEvent.Node.Rerender, {
        componentName: 'Renderer',
        type: 'All',
        time: time,
        nodeCount: nodeCount
      });
    }
  };
  _proto4.componentDidMount = function componentDidMount() {
    this.recordTime();
  };
  _proto4.render = function render() {
    var _container$context, _container$context$ut, _container$context$ut2;
    var _this$props2 = this.props,
      documentInstance = _this$props2.documentInstance,
      renderer = _this$props2.rendererContainer;
    var container = documentInstance.container,
      document = documentInstance.document;
    var designMode = container.designMode,
      device = container.device,
      locale = container.locale;
    var messages = ((_container$context = container.context) === null || _container$context === void 0 ? void 0 : (_container$context$ut = _container$context.utils) === null || _container$context$ut === void 0 ? void 0 : (_container$context$ut2 = _container$context$ut.i18n) === null || _container$context$ut2 === void 0 ? void 0 : _container$context$ut2.messages) || {};
    this.startTime = Date.now();
    this.schemaChangedSymbol = false;
    if (!container.autoRender || (0, _misc.isRendererDetached)()) {
      return null;
    }
    var _createIntl = (0, _locale.createIntl)(locale),
      intl = _createIntl.intl;
    return /*#__PURE__*/React.createElement(_lowcodeReactRenderer["default"], {
      locale: locale,
      messages: messages,
      schema: documentInstance.schema,
      components: container.components,
      appHelper: container.context,
      designMode: designMode,
      device: device,
      documentId: document.id,
      suspended: renderer.suspended,
      self: renderer.scope,
      getSchemaChangedSymbol: this.getSchemaChangedSymbol,
      setSchemaChangedSymbol: this.setSchemaChangedSymbol,
      getNode: function getNode(id) {
        return documentInstance.getNode(id);
      },
      rendererName: "PageRenderer",
      thisRequiredInJSE: _host.host.thisRequiredInJSE,
      notFoundComponent: _host.host.notFoundComponent,
      faultComponent: _host.host.faultComponent,
      faultComponentMap: _host.host.faultComponentMap,
      customCreateElement: function customCreateElement(Component, props, children) {
        var __id = props.__id,
          viewProps = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded2);
        viewProps.componentId = __id;
        var leaf = documentInstance.getNode(__id);
        if ((0, _lowcodeUtils.isFromVC)(leaf === null || leaf === void 0 ? void 0 : leaf.componentMeta)) {
          viewProps._leaf = leaf.internalToShellNode();
        }
        viewProps._componentName = leaf === null || leaf === void 0 ? void 0 : leaf.componentName;
        // 如果是容器 && 无children && 高宽为空 增加一个占位容器，方便拖动
        if (!viewProps.dataSource && leaf !== null && leaf !== void 0 && leaf.isContainer() && (children == null || Array.isArray(children) && !children.length) && (!viewProps.style || Object.keys(viewProps.style).length === 0)) {
          var defaultPlaceholder = intl('Drag and drop components or templates here');
          var lockedNode = (0, _lowcodeUtils.getClosestNode)(leaf, function (node) {
            var _node$getExtraProp;
            return (node === null || node === void 0 ? void 0 : (_node$getExtraProp = node.getExtraProp('isLocked')) === null || _node$getExtraProp === void 0 ? void 0 : _node$getExtraProp.getValue()) === true;
          });
          if (lockedNode) {
            defaultPlaceholder = intl('Locked elements and child elements cannot be edited');
          }
          children = /*#__PURE__*/React.createElement("div", {
            className: (0, _classnames["default"])('lc-container-placeholder', {
              'lc-container-locked': !!lockedNode
            }),
            style: viewProps.placeholderStyle
          }, viewProps.placeholder || defaultPlaceholder);
        }
        if (viewProps._componentName === 'a') {
          delete viewProps.href;
        }
        // FIXME: 渲染仍有问题
        if (viewProps._componentName === 'Menu') {
          Object.assign(viewProps, {
            _componentName: 'Menu',
            className: '_css_pesudo_menu_kbrzyh0f',
            context: {
              VE: window.VisualEngine
            },
            direction: undefined,
            events: {
              ignored: true
            },
            fieldId: 'menu_kbrzyh0f',
            footer: '',
            header: '',
            mode: 'inline',
            onItemClick: {
              ignored: true
            },
            onSelect: {
              ignored: true
            },
            popupAlign: 'follow',
            selectMode: false,
            triggerType: 'click'
          });
        }
        if (!(0, _lowcodeUtils.isReactComponent)(Component)) {
          console.error(viewProps._componentName + " is not a react component!");
          return null;
        }
        return /*#__PURE__*/(0, _react.createElement)(getDeviceView(Component, device, designMode), viewProps, leaf !== null && leaf !== void 0 && leaf.isContainer() ? children == null ? [] : Array.isArray(children) ? children : [children] : children);
      },
      __host: _host.host,
      __container: container,
      onCompGetRef: function onCompGetRef(schema, ref) {
        documentInstance.mountInstance(schema.id, ref);
      },
      enableStrictNotFoundMode: _host.host.enableStrictNotFoundMode
    });
  };
  return Renderer;
}(_react.Component)) || _class3;